/*

lcdwho - display logged-in users on lcdproc server
Copyright (C) 1999 Dale Osowski

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.
                
This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.
                                
You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.


Author can be reached at osowski@bigfoot.com

*/                                            
                                            

#include "comm.h"
#include "sockets.h"
#include <stdio.h>
#include <string.h>
#include <unistd.h>
#include <sys/socket.h>

int lcd_init(char *server, int port, struct lcd_spec *mylcd)
{
	int sock;
	int len = 0;
	char buf[400];
	char *tmp;
	
	sock = sock_connect(server, port);
	if(sock <= 0)
	{
		fprintf(stderr, "Error connecting to server %s on port %i.\n", server, port);
		return 0;
	}

		/* Give server a chance to catch up. */
	usleep(250000);
		/* Get initial text from non-lcdproc server */		
	len = sock_recv(sock, buf, 400);
	if(len >= 0)
	{
		fprintf(stderr, "Not an lcdproc server!\n");
		shutdown(sock, 2);
		exit(0);
	}	

	sock_send_string(sock, "hello\n");
	
	usleep(500000);
	len = sock_recv(sock, buf, 400);	
	printf("buf: %d, %s\n", len, buf);
	if(strlen(buf) < 15)
	{
		fprintf(stderr, "Not an lcdproc server!\n");
		shutdown(sock, 2);
		exit(0);
	}
	
	tmp = strtok(buf, " ");				// "connect"
	if(strcmp(tmp, "connect"))
	{
		fprintf(stderr, "Not an lcdproc server!\n");
		shutdown(sock, 2);
		exit(0);
	}
	
	tmp = strtok(NULL, " ");			// "LCDproc"
	if(strcmp(tmp, "LCDproc"))
	{
		fprintf(stderr, "Not an lcdproc server!\n");
		shutdown(sock, 2);
		exit(0);
	}

/* From here we'll assume this really is an lcdproc server */

	strtok(NULL, " ");				// version
	strtok(NULL, " ");				// "protocol"
	strtok(NULL, " ");				// protocol
	strtok(NULL, " ");				// "lcd"
	strtok(NULL, " ");				// "wid"
	mylcd->lcd_wid = atoi(strtok(NULL, " "));	// width of LCD
	strtok(NULL, " ");				// "hgt"
	mylcd->lcd_hgt = atoi(strtok(NULL, " "));	// height of LCD
	strtok(NULL, " ");				// "cellwid"
	mylcd->cell_wid = atoi(strtok(NULL, " "));	// width of cell
	strtok(NULL, " ");				// "cellhgt"
	mylcd->cell_hgt = atoi(strtok(NULL, " "));	// height of cell
		
	return sock;
}

void set_priority(int sock, int priority)
{
	char tmp[100];
	sprintf(tmp, "screen_set whoscr priority %d\n", priority);
	sock_send_string(sock, tmp);
}


